﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;

namespace MouseGetPostionTestDemo
{
    public class PointFormatProvider : IFormatProvider, ICustomFormatter
    {
        private TypeEnum type = TypeEnum.Left;

        public string Format(string format, object arg, IFormatProvider formatProvider)
        {
            //会按照三次返回 
            //分别是:
            //x1  double
            //',' char
            //x2  double
            if (arg != null)
            {
                if (arg is double)
                {
                    double d = (double)arg;

                    if (type == TypeEnum.Left)
                    {
                        type = TypeEnum.Right;
                        return "( " + d.ToString("F2");
                    }
                    else if (type == TypeEnum.Right)
                    {
                        return d.ToString("F2") + " )";
                    }
                }
                else if (arg is char)
                {
                    return " " + (char)arg + " ";
                }
            }

            return "";
        }

        public object GetFormat(Type formatType)
        {
            return formatType == typeof(ICustomFormatter) ? this : null;
        }

        private enum TypeEnum
        {
            Left = 0,
            Right = 1
        }
    }
}
